stages:
  - build
  - test


# Latest: https://about.gitlab.com/releases/2022/10/22/gitlab-15-5-released/#run-security-scanning-tools-in-merge-request-pipelines
# From 2022/10/22 GitLab 15.5

# GitLab application security scans run in CI/CD pipelines. By default, scan jobs only run in branch pipelines.

# Now, you can also run scans in merge request (MR) pipelines by switching to the Latest version of the CI/CD templates instead of the Stable version. This makes it easier to use security scanning if you design your CI/CD pipelines around MR events.

# We plan to update the Stable templates with this change in GitLab 16.0.

include:
  #- template: Jobs/SAST.latest.gitlab-ci.yml
  - template: Jobs/Dependency-Scanning.latest.gitlab-ci.yml
  - template: Security/Container-Scanning.latest.gitlab-ci.yml

variables:
    # Use Trivy or Grype as security scanners (Trivy is the default in the included template)
    # CS_ANALYZER_IMAGE: "registry.gitlab.com/security-products/container-scanning/trivy:4"
    # CS_ANALYZER_IMAGE: "registry.gitlab.com/security-products/container-scanning/grype:4"
    # Detect language libraries as dependencies
    CS_DISABLE_LANGUAGE_VULNERABILITY_SCAN: "false"
    # Test the vulnerable log4j image 
    DOCKER_IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA

container_scanning:
  tags: [ saas-linux-large-amd64 ]
  variables:
    GIT_STRATEGY: fetch

build-project-docker-image:
  stage: build
  tags: [ saas-linux-large-amd64 ]
  image:
    name: gcr.io/kaniko-project/executor:debug
    entrypoint: [""]
  rules:
    - if: $CI_COMMIT_BRANCH == "main"
    - if: $CI_MERGE_REQUEST_IID
  variables:
    JSON_CONFIG: |
      {
        "auths": {
          "$CI_REGISTRY": {
            "username": "$CI_REGISTRY_USER",
            "password": "$CI_REGISTRY_PASSWORD"
          }
        }
      }
  script: |
    echo "${JSON_CONFIG}" > /kaniko/.docker/config.json
    /kaniko/executor \
      --context $CI_PROJECT_DIR \
      --dockerfile $CI_PROJECT_DIR/Dockerfile \
      --cache=true \
      --destination $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA
      #--destination $CI_REGISTRY_IMAGE/$SUB_DIR:$CI_COMMIT_TAG


